
#ifndef ENTRY_H
#define ENTRY_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "heap.h"
#include "trans.h"

struct tr_entry_s
{
	int itemNo;  // a list of itemNo in the adjacent entries form an itemset
	int freq;
	int delta;
	int level;
};

typedef struct tr_entry_s tr_entry;
typedef tr_entry *tr_entryPtr;

//void tr_addEntry(tr_entryPtr *inS, int *noOfElt, int *itemset, int itemsetSize, int freq, double probInsert);
//void tr_delEntryIndex(tr_entryPtr *inS, int *noOfElt, int index);
void testEntry();

//void entry_combineStart(tr_entryPtr *inT, int *noOfT, heapPtr *inH, int b_current, int belta, int noOfItem, int noOfTrans);
void entry_combineStart(tr_entryPtr *inT, int *noOfT, tr_entryPtr *inNewT, int *noOfNewT, heapPtr *inH, int b_current, int belta, int slideNo, int noOfBatchSlide, int noOfItem, int noOfTrans);
void t_printEntry(tr_entryPtr T, int noOfT);
void entry_removeBatchCount(tr_entryPtr *inT, int *noOfT, tr_entryPtr inOldT, int noOfOldT, int b_current, int belta, int slideNo, int noOfBatchSlide, int noOfItem, int noOfTrans);

#endif

