
#include <stdio.h>
#include <stdlib.h>

#include "trans.h"
#include "fptN20.h"

int topK;

int D;

int noOfItem;
int noOfTrans;

int noOfSkip = 0;

int R = 1000;

int maxTransSize;
int noOfTransRead;
double sigma;

char *configFile = "configSample.txt";

int noOfBatch;


void topNeg_input(char *configFile)
{
 FILE *fp;
 float thresholdDecimal;
 float floatNo;



 if ((fp = fopen(configFile, "r")) == NULL) {
        printf("Can't open config. file, %s.\n", configFile);
        exit(1);
 }

 fscanf(fp, "%d %d %f %d %d %f", &N, &expectedK, &thresholdDecimal, &numItem, &numTrans, &decreaseRate);
 fscanf(fp, "%s %s %s", dataFile, treeFile, outFile);

 noOfItem = numItem;
 noOfTrans = numTrans;
 topK = N;

 fscanf(fp, "%d", &D);
 fscanf(fp, "%d", &maxTransSize);
 fscanf(fp, "%d", &noOfTransRead);
 fscanf(fp, "%f", &floatNo);
 fscanf(fp, "%d", &R);
 fscanf(fp, "%d", &noOfBatch);

 sigma = (double) floatNo;



 fclose(fp);
/*
 printf("N = %d\n", N);
 printf("expectedK = %d\n", expectedK);
 printf("thresholdDecimal = %f (dummy)\n", thresholdDecimal);
 printf("numItem = %d\n", numItem);
 printf("numTrans = %d\n", numTrans);
 printf("decreaseRate = %f\n", decreaseRate);
 printf("dataFile = %s\n", dataFile);
 printf("treeFile = %s\n", treeFile);
 printf("outFile = %s\n\n", outFile);
*/
 threshold = (int) (thresholdDecimal * numTrans);
 //printf("threshold = %d (dummy)\n", threshold);

 //oldThreshold = numTrans;

 if (N > numItem) {
	printf("N > numItem\n");
	exit(1);
 }	

 if (noOfTransRead > noOfTrans)
 {
	 printf("no. of trans. read > no. of trans in the data set!\n");
	 exit(1);
 }

 
 return;
}

int main()
{
/*	int *noOfTopK;

	int i, j, k;

	entryPtr *itemset;
*/

	//double no = 10;

	//test2();

	//test();

	printf("Reading the config...\n");
	topNeg_input(configFile);

/*
	noOfTopK = (int *) malloc(sizeof(int)*expectedK);

	for (i = 0; i < 100;i ++)
	{
		printf(" No. %d\n", i);
		//entryPtr *processBOMO(char *configFilename, int startIndex, int bucketSize, int topK, int L, int *noOfTopK)
		itemset = processBOMO(configFile, 0, R, 600, expectedK, noOfTopK);

		for (j = 0; j < expectedK; j++)
		{
			for (k = 0; k < noOfTopK[j]; k++)
			{
				free(itemset[j][k].item);
			}
			free(itemset[j]);
		}
		free(itemset);
	}
*/

	printf("Testing...\n");
	topNeg_process();

	//printf("log(%.2f) = %.2f\n", no, log(no));

	return 0;
}
