
#ifndef FPT_N_H
#define FPT_N_H

#include "trans.h"


/***** Data Structure *****/
typedef struct FPnode *FPTreeNode;

typedef struct Childnode *childLink;
typedef struct Childnode {
	FPTreeNode node;
	childLink next;
} ChildNode;

typedef struct FPnode {
        /* int leaf; */
        int item;
        int count;
	int numPath; 
	FPTreeNode parent;
        childLink children;
        FPTreeNode hlink;
} FPNode;


typedef struct Itemsetnode *LargeItemPtr;
typedef struct Itemsetnode {
	int support;
	int *itemset;
	LargeItemPtr next;
} ItemsetNode;

void pass1(int startIndex, int bucketSize);
void insert_tree(int *freqItemP, int *indexList, int count, int ptr, int length, 
			FPTreeNode T, FPTreeNode *headerTableLink, int *path)  ;
void q_sortA(int *indexList, int *freqItemP, int low, int high, int size);
entryPtr *processBOMO(char *configFilename, int startIndex, int bucketSize, int topK, int L, int *noOfTopK);

#endif
