#ifndef TRANS_H
#define TRANS_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "qsort.h"

struct trans_s
{
	int noOfItem;
	int *item;
};

typedef struct trans_s trans;
typedef trans *transPtr;


struct entry_s
{
	int itemsetSize;
	int *item;
	int count;

	int isMark;

};

typedef struct entry_s entry;
typedef entry *entryPtr;



extern int topK;
extern int expectedK;
extern char dataFile[300];
extern char treeFile[300];
extern char outFile[300];

extern int D;

extern int noOfItem;
extern int noOfTrans;

extern int noOfSkip;

extern int maxTransSize;
extern double sigma;

extern int noOfTransRead;

extern int numItem;
extern int numTrans;
extern int N;
extern int threshold;
extern float decreaseRate;

extern int R;

extern int noOfBatch;

extern char *configFile;

void addEntry(entryPtr *bucket, int noOfPreEntry, int *itemset, int itemsetSize, int freq);
void topNeg_process();
void test2();
void test();

#endif
